 <?php

require_once(dirname(__FILE__) . '/../dmtpayamak.php');
class Ghasedak
{
    public $prefix;
    public $username;
    public $password;
    public $errors = array();
    private $module;
    private $sms;
    
    public function __construct()
    {
         
    }
    
    public function setProperty($prefix, $username, $password)
    {
        $this->prefix   = $prefix;
        $this->username = $username;
        $this->password = $password;
        $this->connectToWebService();
    }
    public function connectToWebService()
    {
        $this->sms =  new SoapClient('http://parsasms.com/webservice/v2.asmx?WSDL', array('encoding'=>'UTF-8'));
        if(!$this->sms)
            $this->errors[]=Tools::displayError('can not connect to webservice');
    }
    
    public function sendOne($text, $phonenumber, $status)
    {
        $this->module   = new DMTPayamak();
        
         $sendNumber=Configuration::get($this->prefix . 'SENDERNUMBER');
        if($sendNumber==0)
        return $this->handleError(-5);
        
        $reciverNumbers=explode(';',$phonenumber);
        
        $parameters['username']=$this->username;
        $parameters['password']=$this->password;
        $parameters['senderNumbers']=array($sendNumber);
        $parameters['recipientNumbers']=$reciverNumbers;
        $parameters['messageBodies']=array($text);
        try {
            
            $result = $this->sms->SendSMS($parameters)->SendSMSResult->long;
			if(is_array($result))
			{$result = $result[0];}
			
			
        }
        catch (soap_fault $e) {
            return $e;
        }
        
        //handle error
        if ($result < 20 ) 
        {
			$error = $this->handleError($result);
            $this->module->saveLogs($status, $error);
            return $error;
        } 
        else
        {
            $this->module->saveLogs($status, $result);
            return 'sent';
            
        }
    }
    
    protected function handleError($error)
    {
        $this->module   = new DMTPayamak();
        switch ($error) {
            case  1:
                return $this->module->l('User name or password is wrong');
                break;
            
            case 9:
                return $this->module->l('Amount is not sufficient to account');
                break;
            
            case 5:
                return $this->module->l('panel is in update progress');
                break;

            case 6:
                return $this->module->l('Users Have been blocked');
                break;
            case 8:
                return $this->module->l('Invalid To number');
                break;    
            default:
                return $this->module->l('unkwon error');
				echo $result;
                break;
                
        }
    }
    
    public function getContentForm()
    {
        $this->module   = new DMTPayamak();
        $return='<h4>'.$this->module->l('Ghasedak').'</h4>
        <fieldset>
            <legend><img src="' . _MODULE_DIR_ . 'payamak/views/img/settings.gif" alt="" title="" /> ' . $this->module->l('account information') . '</legend>
            <form name="config" action="' . $_SERVER['REQUEST_URI'] . '" method="post">
                <label>' . $this->module->l('Username:') . '</label>
                <div class="margin-form"><input type="text" name="USERNAME" value="' . Configuration::get($this->prefix . 'USERNAME') . '" /><br />' . $this->module->l('username of acoount in website') . '</div>
                <br />
                <label>' . $this->module->l('Password:') . '</label>
                <div class="margin-form"><input type="text" name="PASSWORD" value="' . Configuration::get($this->prefix . 'PASSWORD') . '" /></div>
                <label>' . $this->module->l('sender phone:') . '</label>
                <div class="margin-form"><input type="text" name="SENDERNUMBER" value="' . Configuration::get($this->prefix . 'SENDERNUMBER') . '" /><br />' . $this->module->l('ex:3000XXXXXXXXX') . '</div>
                
                <label>' . $this->module->l('Admin phone:') . '</label>
                <div class="margin-form"><input type="text" name="ADMINPHONE" value="' . Configuration::get($this->prefix . 'ADMINPHONE') . '" style="margin-bottom:10px;" /><br />' . $this->module->l('ex: 09123456789') . '</div>
                <br />
                <div class="margin-form"><input class="button" name="updateInfo" value="' . $this->module->l('Update informations') . '" type="submit" /></div>
                </fieldset>
                <br />';
        return $return;
    }
    public function getContentFooter()
    {
        $return='<fieldset style="text-align:center">
			<a href="http://sms.ghasedak-ict.com" target="_blank"> <span style="color:blue">'.$this->module->l('Ghasedak').'</span></a><br />
			<a href="http://sms.ghasedak-ict.com" target="_blank">Copy Right <span style="color:green">Ghasedak</span></a>
            </fieldset><br />';
        return $return;
    }
} 
